SystemOrganization addCategory: #'HedgeHacks-BFD'!

SketchMorph subclass: #TSnapshotMorph
	instanceVariableNames: 'snapshot thumbnail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HedgeHacks-BFD'!

!TSnapshotMorph methodsFor: 'drawing' stamp: 'ar 2/2/2006 23:37'!
drawOn: aCanvas
	| size max scale width height form sketchForm |
	(thumbnail == snapshot form) ifFalse:[
		thumbnail := snapshot form ifNil:[^self].
		size := owner owner largeExtent.
		max := thumbnail width max: thumbnail height.
		scale := size x / max.
		width := (thumbnail width * scale) truncated.
		height := (thumbnail height * scale) truncated.
		form := Form extent: width@height depth: 16.
		thumbnail displayScaledOn: form.
		sketchForm := Form extent: size depth: form depth.
		form displayOn: sketchForm at: sketchForm extent - form extent // (2@1) rule: Form paint.
		self form: sketchForm.
	].
	super drawOn: aCanvas.
	self framesToDwell <= 0 ifTrue:[snapshot update: true].! !

!TSnapshotMorph methodsFor: 'accessing' stamp: 'ar 2/2/2006 23:13'!
snapshot
	^snapshot! !

!TSnapshotMorph methodsFor: 'accessing' stamp: 'ar 2/2/2006 23:13'!
snapshot: aSnapshot
	snapshot := aSnapshot! !

CroquetParticipant subclass: #BFDParticipant
	instanceVariableNames: 'dock windowData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HedgeHacks-BFD'!

!BFDParticipant commentStamp: '<historical>' prior: 0!
The participant for our big funding demo.!

BFDParticipant subclass: #BFDMaster
	instanceVariableNames: 'contactBroadcaster'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HedgeHacks-BFD'!

!BFDMaster commentStamp: '<historical>' prior: 0!
The master for our big funding demo.!

!BFDMaster class methodsFor: 'as yet unclassified' stamp: 'ar 1/17/2006 15:14'!
descriptionForPartsBin
	^ self partName:	'Demo (Master)'
		categories:		#('Croquet')
		documentation:	'Croquet Demo Master'
		sampleImageForm: self defaultForm.! !

!BFDMaster methodsFor: 'as yet unclassified' stamp: 'sn 2/26/2018 12:24'!
delete
	super delete.
	contactBroadcaster ifNotNil:[
		contactBroadcaster stopBroadcaster
		].! !

!BFDMaster methodsFor: 'as yet unclassified' stamp: 'das 1/20/2006 02:01'!
registerPortal: portalName in: island
	| entry pc |
	entry := island future at: portalName.
	pc := entry future postcard.
	pc whenResolved:[harness addIsland: island postcard: pc value.].
	^entry! !

!BFDMaster methodsFor: 'as yet unclassified' stamp: 'sn 2/26/2018 12:34'!
setup
	| pc sync entry island |
	
	contactBroadcaster := TBroadcasterStandalone reset default.
	super setup.
	harness enableIslandCache: false.
false ifTrue:[
	island := harness createIsland: IntroWorld named: 'Intro World'.
	entry := self registerPortal: #mainEntry in: island.
] ifFalse:[
	island := harness createIsland: IntroWorld named: 'Intro World'.
	entry := self registerPortal: #mainEntry in: island.
	self registerPortal: #T3BodyPortal in: island.
	harness makeSnapshot: (island future at: #mainEntry) angle: 0 
		translation:(Vector3 x: 0 y: 0 z: 0).

	island := harness createIsland: T3BodyWorld named: '3Body World'.
	self registerPortal: #IntroPortal in: island.
	harness makeSnapshot: (island future at: #mainEntry) angle: 11 
		translation:(Vector3 x:11.27770042419434 y:10.25 z:100.1538009643555).

	island := harness createIsland: DungeonWorld named: 'Dungeon World'.
	self registerPortal: #IntroPortal in: island.
	harness makeSnapshot: (island future at: #mainEntry) angle: 11 
		translation:(Vector3 x:16.52985000610352 y: -32.47652435302734 z: -103.7088470458984).

	island := harness createIsland: MarsWorld named: 'Mars World'.
	self registerPortal: #IntroPortal in: island.
	harness makeSnapshot: (island future at: #mainEntry) angle: 15
		translation:(Vector3 x:21.26738166809082 y: -17.4773292541504 z:38.1824035644531).

	island := harness createIsland: UnderwaterWorld named: 'Underwater World'.
	self registerPortal: #IntroPortal in: island.

	island := harness createIsland: SpreadSheetWorld named: 'Spreadsheet World'.
	self registerPortal: #IntroPortal in: island.
	harness makeSnapshot: (island future at: #mainEntry) angle: -40
		translation:(Vector3 x: -6.16044044494629 y:0.25 z:8.65220928192139).
].
	"Drop into the intro world"
	pc := entry future postcard.
	pc whenResolved:[
		sync := harness  viewPortal future postcardLink: pc value.
		sync whenResolved:[harness startRender]. "ready to render"
	].
	pc wait.
! !

!BFDParticipant class methodsFor: 'as yet unclassified' stamp: 'ar 1/17/2006 15:14'!
descriptionForPartsBin
	^ self partName:	'Demo (Participant)'
		categories:		#('Croquet')
		documentation:	'Croquet Demo Participant'
		sampleImageForm: self defaultForm.! !

!BFDParticipant methodsFor: 'zoom navigator' stamp: 'ar 1/22/2006 14:03'!
addZoomNavigator
	dock := TZoomNavigatorMorph new.
	dock position: self bounds bottomLeft.
	dock fullBounds. "need the layout!!"
	dock width: self width.
	self addMorph: dock.
	dock mouseLeave: nil.
	dock addProjectRoot.
	dock addSnapshotRoot.
	dock addToolsRoot.
	dock addAvatarRoot.
	dock addTool: TPainter.
	"dock addTool: TSpaceBrowser.
	dock addTool: TConnectionDialog."! !

!BFDParticipant methodsFor: '3d sketch' stamp: 'ar 1/17/2006 14:14'!
clickOpenAliceFile: filePath
	| fName frame imported pos camera |
true ifTrue:[
	^harness avatar loadAvatar: filePath.
].
	"Import TFrame (non-replicated)"
	fName := FileDirectory pathFromURI: filePath.
	Cursor read showWhile:[
		imported := TLoadMDL new parseFileNamed: fName.
	].
	"Copy resulting frame into island"
	Cursor wait showWhile:[
		| copier dstIsland conn |
		dstIsland := harness activeIsland.
		conn := (dstIsland send:[:x|  x controller]) connection.
		conn sendAmount: 0.
		conn sendCount: 0.
		copier := TIslandCopier new.
		MessageTally spyOn:[frame := copier copy: imported to: dstIsland].
		Transcript cr show: 'Messages sent: ', conn sendCount printString.
		Transcript cr show: 'Data sent: ', conn sendAmount printString.
	].
	camera := harness camera.
	pos := camera "avatar" translation - (camera "avatar" lookAt * 10).
	frame future translation: pos.
	harness activeSpace future addChild: frame.
! !

!BFDParticipant methodsFor: 'zoom navigator' stamp: 'bgf 5/14/2006 13:58'!
clickProjectView: aProject
	| fakeSHA morphic space island worldExtent txtr pos win |
	aProject == Project current ifTrue:[^Smalltalk beep].
	worldExtent := 1024@768.
	space := harness activeSpace.
	island := harness activeIsland.
	fakeSHA := TFormManager generateSHA: (TObjectID for: 'Project SHA').
	morphic := island future new: TMorphicForm.
	morphic future
		initialize: nil sha: fakeSHA 
		form: (Form extent: 32@32 depth: 32)
		mipmap: false shrinkFit: true extension: nil. 
	morphic future bThumb: true.
	morphic future worldExtent: worldExtent.
	morphic future constructor: (MessageSend
		receiver: MorphicWorldHost
		selector: #makeProjectLink:extent:from:
		argument: aProject name).

	txtr := island future new: TTextureHackForm.
	txtr future initializeWithTForm: morphic.
	txtr future targetExtent: worldExtent.

	win := self makeWindowIn: island.
	win future contents: txtr.

	"Position it"
	pos := harness avatar translation - (harness avatar lookAt * 10).
	win future translation: pos.
	win future rotationAroundY: harness avatar yaw.
	space future addChild: win.
! !

!BFDParticipant methodsFor: 'initialization' stamp: 'ar 1/23/2006 17:46'!
delete
	TMorphicForm flushHosts.
	super delete.! !

!BFDParticipant methodsFor: 'snapshots' stamp: 'ar 2/2/2006 23:23'!
gotoSnapshot: snapMorph
	harness gotoSnapshot: snapMorph snapshot! !

!BFDParticipant methodsFor: 'initialization' stamp: 'ar 1/17/2006 14:11'!
initialize
	super initialize.
	TZoomNavigatorMorph initialize. "check for new icons"
	self extent: 600@400.
	self addZoomNavigator.! !

!BFDParticipant methodsFor: '3d sketch' stamp: 'ar 3/8/2006 20:16'!
make3DObject: style from: aForm player: aPlayer rotateBy: rot replaceOldCostume: aBoolean
	| bbForm tex mat scale space island tform tfm mesh pos frame t3dMesh |
	style == #billboard ifTrue:[^self popUpBillboard: aForm player: aPlayer].
	space := harness activeSpace.
	island := harness activeIsland.

	"Convert the form"
	bbForm := Form extent: aForm extent asSmallerPowerOfTwo depth: 32.
	aForm displayScaledOn: bbForm in: (bbForm boundingBox insetBy: 1).
	"Smear the borders of the texture a bit to prevent problems in texture mapping"
	bbForm smearFill: 10. "pixels - less is faster but more is safer"

	"Create the texture"
	tform := island future new: TForm.
	tform future initialize: nil form: aForm mipmap: true 
		shrinkFit: true extension: #colorKeyZero.
	tex := island future new: TTexture.
	tex future initializeWithTForm: tform.

	"The material"
	mat := island future new: TMaterial.
	mat future ambientColor: #(0.8 0.8 0.8 1) asFloatArray.
	mat future diffuseColor: #(0.8 0.8 0.8 1) asFloatArray.

	mat future texture: tex.
	mat future textureMode: GLModulate.

	"The t3d mesh"
	t3dMesh := T3DSubdivision make3DMeshFrom: aForm style: style.
	scale := 0.01.

	tfm := (Quaternion axis: 1@0@0 angle: 180) asMatrix4x4.
	tfm := tfm composeWith: (Quaternion axis: 0@1@0 angle: rot) asMatrix4x4.
	tfm := tfm composeWith: (Matrix4x4 withScale: scale@scale@scale).
	tfm := tfm composeWith: (Matrix4x4 withOffset: (aForm width * -0.5) @ (aForm height * -0.5) @ 0).
	t3dMesh transformBy: tfm.

	"The TMesh"

	mesh := island future new: TMesh.
	mesh future
		initializeWithVertices: t3dMesh vertices 
		alias: nil 
		norms: t3dMesh vertexNormals
		textureUV: t3dMesh texCoords
		faceGroups: {1. t3dMesh zeroBasedFaceGroup}
		material: mat.
	mesh future solid: false.
	mesh future initBounds.

	frame := island future new: TDragger.
	frame future contents: mesh.

	"Position it"
	pos := harness avatar translation - (harness avatar lookAt * 10).
	frame future translation: pos.
	frame future rotationAroundY: harness avatar yaw + rot.
	space future addChild: frame.
! !

!BFDParticipant methodsFor: 'zoom navigator' stamp: 'ar 2/2/2006 12:09'!
makeWindowIn: anIsland
	"Create a window in the given space. This is an ugly solution but it works..."
	windowData ifNil:[windowData := TIslandCopier new export: TWindow new].
	^TIslandCopier new import: windowData to: anIsland.! !

!BFDParticipant methodsFor: 'zoom navigator' stamp: 'ar 1/17/2006 14:14'!
openTool: toolClass
	| tool window |
	tool := toolClass new.
	window := tool open.
	self addMorphCentered: window.
	tool postBuildIn: self.
	^tool! !

!BFDParticipant methodsFor: '3d sketch' stamp: 'das 3/2/2006 16:33'!
popUpBillboard: aForm player: aPlayer
	| space bbForm size billboard aPosition texture mat frame island tform camera |

	space := harness activeSpace.
	island := harness activeIsland.

	size := aForm extent * 0.01.
	bbForm := Form extent: aForm extent asSmallerPowerOfTwo depth: 32.
	aForm displayScaledOn: bbForm in: (bbForm boundingBox insetBy: 1).

	tform := island future new: TForm.
	tform future initialize: nil form: aForm mipmap: true 
		shrinkFit: true extension: #colorKeyZero.
	texture := island future new: TTexture.
	texture future initializeWithTForm: tform.
	billboard := island future new: TBillboard.
	texture future aspect: size y / size x asFloat. 
	texture future extent: size * 3.

	mat := island future new: TMaterial.
	mat future ambientColor: #(1 1 1 0.99).
	mat future diffuseColor: #(1 1 1 0.99).
	mat future emissiveColor: #(1 1 1 0.99).

	texture future material: mat.

	billboard future addChild: texture.

	"frame := island future new: TDragger.
	frame future contents: billboard."
	frame := billboard.

	camera := harness camera.
	aPosition := camera "avatar" translation - (camera "avatar" lookAt * 10).
	frame future translation: aPosition.
	space future addChild: frame.
! !

!BFDParticipant methodsFor: 'initialization' stamp: 'ar 1/31/2006 17:15'!
setup
	| postcard |
	harness := CroquetHarness new.
	harness addOverlay: self.
	postcard := TPostcard new routerAddress: nil "don't know what it is"
				id: nil "don't know what it is"
				name: 'Intro World' 
				viewpointName: #mainEntry.
	harness viewPortal future postcardLink: postcard.
	harness findViewpointByPostcard: postcard.
! !

!BFDParticipant methodsFor: 'snapshots' stamp: 'ar 2/2/2006 23:24'!
step
	harness ifNotNil:[self updateSnapshots].
	super step.! !

!BFDParticipant methodsFor: 'snapshots' stamp: 'ar 2/2/2006 23:24'!
updateSnapshots
	(harness snapshots) = (dock snapshots collect:[:each| each snapshot]) ifFalse:[
		dock snapshots: (harness snapshots collect:[:each| TSnapshotMorph new snapshot: each])
	].
! !

BFDParticipant subclass: #TEmbeddedAppMaster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HedgeHacks-BFD'!

!TEmbeddedAppMaster commentStamp: '<historical>' prior: 0!
(c) 2006 Qwaq Inc. An example for using embedded apps.!

!TEmbeddedAppMaster class methodsFor: 'as yet unclassified' stamp: 'tmp 7/17/2006 16:21'!
descriptionForPartsBin
	^ self partName:	'Embedd App (Master)'
		categories:		#('Croquet')
		documentation:	'Croquet Embedded App Master'
		sampleImageForm: self defaultForm.! !

!TEmbeddedAppMaster methodsFor: 'initialize' stamp: 'tmp 7/17/2006 16:19'!
registerPortal: portalName in: island
	| entry pc |
	entry := island future at: portalName.
	pc := entry future postcard.
	pc whenResolved:[harness addIsland: island postcard: pc value.].
	^entry! !

!TEmbeddedAppMaster methodsFor: 'initialize' stamp: 'ar 7/17/2006 16:50'!
setup
	| pc sync entry island |
	harness := CroquetHarness new.
	harness addOverlay: self.
	island := harness createIsland: EmbeddedWorld named: 'Embedded World'.
	entry := self registerPortal: #mainEntry in: island.
	pc := entry future postcard.
	pc whenResolved:[
		sync := harness viewPortal future postcardLink: pc value.
		sync whenResolved:[harness startRender]. "ready to render"
	].
	pc wait.! !

Object subclass: #BaseWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants'
	category: 'HedgeHacks-BFD'!

!BaseWorld commentStamp: '<historical>' prior: 0!
Base world constructor with a few utility methods.!

!BaseWorld methodsFor: 'toys' stamp: 'das 5/28/2006 22:38'!
makeFloor: sp fileName: txtrName
	| stone txt mat |
	txt := TTexture
				new initializeWithFileName: txtrName
				mipmap: true
				shrinkFit: false.
	txt uvScale: 8.0@8.0.
	mat := TMaterial new.
	mat texture: txt.
	stone := TCube new.
	stone extentX:80 y:0.5 z: 80.
	stone translationX: 0 y: -6.0 z: 0.0.
"	stone texture: txt."
	stone material: mat.
	stone objectName: 'floor' copy.
	sp addChild: stone.
	^ stone.

! !

!BaseWorld methodsFor: 'toys' stamp: 'ar 1/18/2006 13:16'!
makeLight: sp
	| light tframe |
	light := TLight new.
	tframe := TSpinner new.
	tframe translationX: -10 y:0.0 z: 0.0.
	tframe rotationAroundZ: 120.
	"This is to avoid some odd lighting effects"
	tframe rotateBy: 1 around: 1@0@0.
	tframe matNil.
	tframe contents: light.
	sp addChild: tframe.! !

!BaseWorld methodsFor: 'toys' stamp: 'bgf 5/14/2006 13:58'!
makeMorphic: constructor extent: worldExtent
	| morphic txtr fakeSHA |
	fakeSHA := TFormManager generateSHA: (TObjectID for: 'SHA').
	morphic := TMorphicForm new 
		initialize: nil sha: fakeSHA 
		form: (Form extent: 32@32 depth: 32)
		mipmap: false shrinkFit: true extension: nil. 
	morphic bThumb: true.
	morphic constructor: constructor.
	morphic worldExtent: worldExtent.

	"@@@@ The following is VERY important since later we'll need the TMorphic's farRef but we cannot create it in render, so forcing it here is a must @@@@"
	morphic island asFarRef: morphic.

	txtr := TTextureHackForm new initializeWithTForm: morphic.
	txtr targetExtent: worldExtent.
	^txtr! !

!BaseWorld methodsFor: 'toys' stamp: 'hrs 11/15/2006 06:36'!
makePortal: textureName
	| p1 win pic |
	p1 := TPortal new.
	win := self makeWindow.
	win contents: p1.
	textureName ifNotNil:[
		pic := TTexture
					new initializeWithFileName: textureName
					mipmap: true
					shrinkFit: false.
		win rectFront: pic.
	].
	win closeContents.
	win showOpenButton.
	^win! !

!BaseWorld methodsFor: 'toys' stamp: 'das 3/2/2006 16:33'!
makeWidget: uri scale: scl

	| frame fileName |
	fileName := FileDirectory pathFromURI: uri.
	frame := (TLoad3DSMax new initializeWithFileName: fileName scale: scl) frame.
	frame boundsDepth: 1.
	frame initBounds.
	frame do:[ :tf |
		tf isMesh ifTrue:[ tf materialList do:[ :ml |
			ml ambientColor: #(0.2 0.5 1.0 0.8).
			ml diffuseColor:#(0.2 0.5 1.0 0.8).
			ml textureMode: GLModulate.
		]].
		tf checkAlpha.
	].
	^frame! !

!BaseWorld methodsFor: 'toys' stamp: 'hrs 11/15/2006 06:35'!
makeWindow
	"Already has a cache mechanism in class #new.
	However, this is overrideable by BaseWorld subclasses."
	^TWindow new.! !

BaseWorld subclass: #DungeonWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HedgeHacks-BFD'!

!DungeonWorld commentStamp: '<historical>' prior: 0!
The dungeon world constructor.!

!DungeonWorld class methodsFor: 'as yet unclassified' stamp: 'ar 1/18/2006 11:00'!
islandID
	^TObjectID readHexFrom: '98b17cdc2f2b5085ed4b7871a63607db'! !

!DungeonWorld methodsFor: 'initialize' stamp: 'bgf 3/9/2006 17:21'!
initialize
	| lt space spinner sky mesh win pc portal waterTop waterfall waterBottom |
	Processor activeIsland id: self class islandID.
	space := TSpace new.
	space registerGlobal: #mainEntry.

	space color:(VectorColor r: 0.5 g: 0.7 b: 0.6 a: 1.0).
	space fogOn: true.
	space fogDensity: 0.0015.
	space fogStart: 100.0.
	space fogEnd: 6000.0.

	lt := TLight new.
	lt ambientColor: #(1 1 1 1).
	lt diffuseColor: #(1 1 1 1).
	lt specularColor: #(0.2 0.15 0.15 1.0).
	lt visible: false.

	spinner := TSpinner new.
	spinner translationX: -10 y:0.0 z: 0.0.
	spinner matNil.
	spinner contents: lt.
	spinner addRotationAroundZ: 120.
	spinner addRotationAroundY:-10.
	spinner translationX: -30 y:-32 z: -76.

	space addChild: spinner. " add the light"

	sky := TSkyBox new initializeWithFileName: 'CA'.
	sky step. "get going"
	space addChild: sky.

	mesh := (TLoad3DSMax new initializeWithFileName: 
		(FileDirectory pathFromURI: 'Content/DungeonDemo/space5.ASE') 
		scale: 0.035 shadeAngle: 90.1 textureMode: GLModulate) frame.
	mesh translationX: -67 y: -3.0 z:-208.0.
	mesh boundsDepth: 3.
	mesh initBounds.

	waterTop := (mesh find:[:frm | frm objectName = '$WaterfallTop'])at:1.
	waterfall := self makeWaterfall: waterTop translation.
	waterTop parent addChild: waterfall.
	waterTop removeSelf.
	waterBottom := (mesh find:[:frm | frm objectName = '$WaterfallBottom'])at:1.
	waterfall := self makeWaterfallBottom: waterBottom translation.
	waterBottom parent addChild: waterfall.
	waterBottom removeSelf.

	TQuadTree new initializeWithSpace: space frame: mesh.

	win := self makePortal: nil.
	win translationX: -5 y: -32 z: -78.
	win openContents.
	pc := TPostcard new routerAddress: nil "don't know what it is"
				id: IntroWorld islandID
				name: 'Intro World'
				viewpointName: #DungeonPortal.

	portal := win contents.
	portal postcardLink: pc.
	portal registerGlobal: #IntroPortal.
	space addChild: win.! !

!DungeonWorld methodsFor: 'initialize' stamp: 'das 3/2/2006 16:34'!
makeWaterfall: trans

	| ptxtr aMat tframe |
	ptxtr := TTexture new initializeWithFileName: 'Water1.BMP' mipmap: false shrinkFit: false extension: #colorKey.
	ptxtr aspectFixed: false.
	ptxtr extent: 3@12.
	aMat := TMaterial new.
	aMat ambientColor: #(1.0 1.0 1.0 0.4).
	aMat diffuseColor: #(1.0 1.0 1.0 0.4).
	ptxtr material: aMat.
	tframe := TParticleTxtr new initializeWithSize: 100.
	tframe translation: trans - (1@5@0). "take the size of the texture into account".
	tframe addTexture: ptxtr.
	tframe setLifetimeRange: (1700 to: 2500).
	tframe setPositionRangeMin:(-0.8@-0.1@-0.1) max: (0.8@0.1@0.1).
	tframe setVelocityRangeMin:(-1.2@-0.1@-1.2) max:(1.2@0.1@4.2).
	tframe setAccelerationRangeMin:(0@-25@0) max:(0@-20@0).
	tframe rotationAroundY: -90.
	tframe startColor: #(1.0 1.0 1.0 0.7).
	tframe endColor: #(1.0 1.0 1.0 0.2).
	^ tframe.
! !

!DungeonWorld methodsFor: 'initialize' stamp: 'das 3/2/2006 16:34'!
makeWaterfallBottom: trans

	| ptxtr aMat tframe |
	ptxtr := TTexture new initializeWithFileName: 'Water1.BMP' mipmap: false shrinkFit: false extension: #colorKey.
	ptxtr aspectFixed: false.
	ptxtr extent: 5@5.
	aMat := TMaterial new.
	aMat ambientColor: #(1.0 1.0 1.0 0.2).
	aMat diffuseColor: #(1.0 1.0 1.0 0.2).
	ptxtr material: aMat.
	tframe := TParticleTxtr new initializeWithSize: 100.
	tframe translation: trans + (-3@2.5@0). "take the size of the texture into account".
	tframe addTexture: ptxtr.
	tframe setLifetimeRange: (1500 to: 2000).
	tframe setPositionRangeMin:(-5.0@-0.1@-5.0) max: (5.0@0.1@5.0).
	tframe setVelocityRangeMin:(-1.2@2.0@-1.2) max:(1.2@4.0@4.2).
	tframe setAccelerationRangeMin:(0@-1@0) max:(0@-0.5@0).
	tframe rotationAroundY: -90.
	tframe startColor: #(1.0 1.0 1.0 0.6).
	tframe endColor: #(1.0 1.0 1.0 0.0).
	^ tframe.
! !

BaseWorld subclass: #EmbeddedWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HedgeHacks-BFD'!

!EmbeddedWorld commentStamp: '<historical>' prior: 0!
(c) 2006 Qwaq Inc. An example for using embedded apps.!

!EmbeddedWorld class methodsFor: 'as yet unclassified' stamp: 'tmp 7/17/2006 16:21'!
islandID
	^TObjectID readHexFrom: 'e4cb1585531dc1657d0781c67d119cff'! !

!EmbeddedWorld methodsFor: 'initialize' stamp: 'hrs 11/15/2006 06:36'!
initialize
	| space win sky app |
	Processor activeIsland id: self class islandID.
	space := TSpace new.
	space registerGlobal: #mainEntry.
	self makeLight: space.
	self makeFloor: space fileName:'lawn.BMP'.
	sky := TSkyBox new initializeWithFileName: 'JUL'.
	sky step. "get going"
	space addChild: sky.
"
	app := TEmbeddedApp name: #TSlideShowApp extent: 400@300 data: 'icons'.
"
	app := TEmbeddedApp name: #TSlideShowApp extent: 400@300 data: 'icons'.
	win := self makeWindow.
	win contents: app.
	win translation: (0@0.25@-6).
	space addChild: win.

	^ space.

! !

BaseWorld subclass: #IntroWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HedgeHacks-BFD'!

!IntroWorld commentStamp: '<historical>' prior: 0!
The intro world constructor.!

!IntroWorld class methodsFor: 'as yet unclassified' stamp: 'ar 1/18/2006 12:18'!
islandID
	^TObjectID readHexFrom: '5162ad95011778fcf8cee0a7e6491388'! !

!IntroWorld methodsFor: 'initialize' stamp: 'ar 3/17/2006 13:39'!
initialize
	| space sky |

	Processor activeIsland id: self class islandID.
	space := TSpace new.
	space registerGlobal: #mainEntry.
	self makeLight: space.
	self makeFloor: space fileName:'lawn.BMP'.

"
	waveDemo := self makeWaveDemo: space.
	self makeWaveDemo: waveDemo at: -30@-1@-30 in: space.
	self makeWaveDemo: waveDemo at: 30@-1@-30 in: space.
	self makeWaveDemo: waveDemo at: 30@-1@30 in: space.
	self makeWaveDemo: waveDemo at: -30@-1@30 in: space.
	self world doOneCycleNow.
"
	self makeKay: space.
	self makeMirror: space. 
	self makePyramid: space.

	self makeUnderwaterPortal: space.
"	self makePopUp: space.	"
	self makeChess: space.
	self makeProjectLink: space.
	self makeFlash: space.
"	self makeGalleryPortal: space."
	self makeDungeonPortal: space.
	self make3BodyPortal: space.
	self makeSpreadSheetPortal: space.
	self makeMarsPortal: space.

	Smalltalk at: #QwaqWorld 
		ifPresent:[:qWorld| self makeQwaqPortal: space using: qWorld].
	Smalltalk at: #QwaqWorldRemote
		ifPresent:[:qWorld| self makeQwaqPortalRemote: space using: qWorld].

	sky := TSkyBox new initializeWithFileName: 'JUL'.
	sky step. "get going"
	space addChild: sky.

	^space! !

!IntroWorld methodsFor: 'initialize' stamp: 'das 1/20/2006 02:03'!
make3BodyPortal: sp
	| win pc portal |
	win := self makePortal: 'Reed.bmp'.
	win translationX: -12 y: 0.0 z: -1.0.
	sp addChild: win.

	pc := TPostcard new routerAddress: nil "don't know what it is"
				id: T3BodyWorld islandID
				name: '3Body World'
				viewpointName: #IntroPortal.

	portal := win contents.
	portal postcardLink: pc.
	portal registerGlobal: #T3BodyPortal.! !

!IntroWorld methodsFor: 'initialize' stamp: 'hrs 11/15/2006 06:37'!
makeChess: sp
	| win morphic |
	morphic := TEmbeddedApp name: #TMorphicWorld extent: 512@512 
		data: {#makeMorph:. BouncingAtomsMorph}.

	win := self makeWindow.
	win translationX: 12 y: 0.0 z: -16.0.
	win rotationAroundY: -75.
	win contents: morphic.
	win closeContents.
	sp addChild: win.! !

!IntroWorld methodsFor: 'initialize' stamp: 'ar 1/31/2006 22:53'!
makeDungeonPortal: sp
	| win pc portal |
	win := self makePortal: 'Smith.bmp'.
	win translationX: 12 y: 0.0 z: -1.0.
	sp addChild: win.
	pc := TPostcard new routerAddress: nil "don't know what it is"
				id: DungeonWorld islandID
		"@@@@: The difference in name ('Dungeon' vs. 'Dungeon World') is quite intentional to have at least one place where we try to resolve an island exclusively by ID instead of by name. Otherwise this code will never be executed and therefore rot. @@@@"
				name: 'Dungeon'
				viewpointName: #IntroPortal.
	portal := win contents.
	portal postcardLink: pc.
	portal registerGlobal: #DungeonPortal.! !

!IntroWorld methodsFor: 'initialize' stamp: 'hrs 11/15/2006 06:37'!
makeFlash: sp
	| win morphic |
	morphic := TEmbeddedApp name: #TMorphicWorld extent: 512@256 
		data: {#makeFlash:. 'Content/Movies/actinMyosin2.swf'}.

	win := self makeWindow.
	win translationX: 31 y: 0.0 z: 28.0.
	win rotationAroundY: -90.
	win contents: morphic.
	win closeContents.
	sp addChild: win.
! !

!IntroWorld methodsFor: 'initialize' stamp: 'hrs 11/15/2006 06:37'!
makeGalleryPortal: sp
	| mat p1 win pic |
	mat := TMaterial new.
	p1 := TPortal new.
	p1 material: mat.

	win := self makeWindow.
	win rotationAroundY: 180.
	win translationX: -20 y: 0.0 z: 30.0.
	win contents: p1.
	pic := TTexture
				new initializeWithFileName: 'GrnChplTwr.bmp'
				mipmap: true
				shrinkFit: false.
	win rectFront: pic.
	win openContents.
	sp addChild: win.! !

!IntroWorld methodsFor: 'initialize' stamp: 'hrs 11/15/2006 06:37'!
makeKay: sp
	| env pic win tframe |
	pic := TTexture
				new initializeWithFileName: 'KAY.bmp'
				mipmap: true
				shrinkFit: false.

	env := TTexture
				new initializeWithFileName: 'SkyBoxJULRT.bmp' 
				mipmap: true
				shrinkFit: false.

	tframe := TWaves initializeWithSize: 20@20.
	tframe texture: pic.
	tframe envTexture: env.

	win := self makeWindow.
	win contents: tframe.
	win translationX: 7 y: 0.0 z: -2.0.
	sp addChild: win.

! !

!IntroWorld methodsFor: 'initialize' stamp: 'das 1/20/2006 02:04'!
makeMarsPortal: sp
	| win pc portal |
	win := self makePortal: 'McCahill.bmp'.
	win translationX: -20 y: 0.0 z: 0.0.
	sp addChild: win.
	pc := TPostcard new routerAddress: nil "don't know what it is"
				id: MarsWorld islandID
				name: 'Mars'
				viewpointName: #IntroPortal.
	portal := win contents.
	portal postcardLink: pc.
	portal registerGlobal: #MarsPortal.! !

!IntroWorld methodsFor: 'initialize' stamp: 'ar 1/18/2006 12:22'!
makeMirror: sp
	| win |
	win := self makePortal: nil.
	win translationX: -1 y:0 z: -8.
	sp addChild: win.
! !

!IntroWorld methodsFor: 'initialize' stamp: 'bgf 5/14/2006 14:00'!
makeMorphic: constructor extent: worldExtent
	| morphic txtr fakeSHA |
	fakeSHA := TFormManager generateSHA: (TObjectID for: 'Morphic').
	morphic := TMorphicForm new 
		initialize: nil sha: fakeSHA 
		form: (Form extent: 32@32 depth: 32)
		mipmap: false shrinkFit: true extension: nil. 
	morphic bThumb: true.
	morphic constructor: constructor.
	morphic worldExtent: worldExtent.

	"@@@@ The following is VERY important since later we'll need the TMorphic's farRef but we cannot create it in render, so forcing it here is a must @@@@"
	morphic island asFarRef: morphic.

	txtr := TTextureHackForm new initializeWithTForm: morphic.
	txtr targetExtent: worldExtent.
	^txtr! !

!IntroWorld methodsFor: 'initialize' stamp: 'hrs 11/15/2006 06:37'!
makeProjectLink: sp
	| win morphic |
	morphic := TEmbeddedApp name: #TMorphicWorld extent: 1024@768 
		data: {#makeProjectLink:. 'Squeak Intro for Croquet'}.

	win := self makeWindow.
	win translationX: 8 y: 0.0 z: -20.0.
	win contents: morphic.
	win closeContents.
	sp addChild: win.
	^ win.
! !

!IntroWorld methodsFor: 'initialize' stamp: 'das 3/2/2006 16:35'!
makePyramid: sp
	| pyr matNorm spinner |
	pyr := TSierpinski new.
	matNorm := TMaterial new.
	matNorm ambientColor: #(0.5 0.7 0.7 0.5).
	matNorm diffuseColor: #(0.5 0.7 0.7 0.5).
	pyr material: matNorm.
	pyr scale: 5.0.
	pyr depth: 3.

	spinner := TSpinner new.
	spinner translationX: 12 y:0 z: 12.
	spinner contents: pyr.
	sp addChild: spinner.
! !

!IntroWorld methodsFor: 'initialize' stamp: 'bgf 6/10/2006 13:41'!
makeQwaqPortal: sp using: qwaqWorld

	"This portal will be an unresolved mirror in the general hedgehog world."
	| win pc portal |
	win := self makePortal: 'helicopter.bmp'.
	win translationX: -24 y: 0.0 z: 12.0.
	win rotationAroundY: 90.
	win openContents.
	sp addChild: win.

	pc := TPostcard new routerAddress: nil "don't know what it is"
				id: nil
				name: 'Qwaq Conferencing'
				viewpointName: #IntroPortal.
	portal := win contents.
	portal postcardLink: pc.
	portal registerGlobal: #QwaqPortal.! !

!IntroWorld methodsFor: 'initialize' stamp: 'bgf 6/10/2006 13:40'!
makeQwaqPortalRemote: sp using: qwaqWorld

	| win pc portal |
	win := self makePortal: 'helicopter.bmp'.
	win translationX: -20 y: 0.0 z: 30.0.
	win rotationAroundY: 180.
	sp addChild: win.

	pc := TPostcard new routerAddress: nil "don't know what it is"
				id: qwaqWorld islandID
				name: 'Qwaq Conferencing (DC)'
				viewpointName: #IntroPortal.
	portal := win contents.
	portal postcardLink: pc.
	portal registerGlobal: #QwaqPortalRemote.! !

!IntroWorld methodsFor: 'initialize' stamp: 'das 1/20/2006 02:04'!
makeSpreadSheetPortal: sp
	| win pc portal |
	win := self makePortal: 'Lombardi.bmp'.
	win translationX: 20 y: 0.0 z: 0.0.
	sp addChild: win.

	pc := TPostcard new routerAddress: nil "don't know what it is"
				id: SpreadSheetWorld islandID
				name: 'Spreadsheet Demo'
				viewpointName: #IntroPortal.
	portal := win contents.
	portal postcardLink: pc.
	portal registerGlobal: #SpreadSheetPortal.! !

!IntroWorld methodsFor: 'initialize' stamp: 'ar 1/31/2006 17:46'!
makeUnderwaterPortal: sp
	| win pc portal |
	win := self makePortal: 'Raab.bmp'.
	win translationX: -5 y: 0.0 z: -2.0.
	sp addChild: win.

	pc := TPostcard new routerAddress: nil "don't know what it is"
				id: UnderwaterWorld islandID
				name: 'Underwater World'
				viewpointName: #IntroPortal.
	portal := win contents.
	portal postcardLink: pc.
	portal registerGlobal: #UnderwaterPortal.! !

BaseWorld subclass: #MarsWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HedgeHacks-BFD'!

!MarsWorld commentStamp: '<historical>' prior: 0!
The mars world constructor.!

!MarsWorld class methodsFor: 'as yet unclassified' stamp: 'ar 1/18/2006 11:43'!
islandID
	^TObjectID readHexFrom: 'ecfc86fd0adc8baf12cbcf65084a6af2'! !

!MarsWorld methodsFor: 'as yet unclassified' stamp: 'jcg 3/1/2006 13:59'!
initialize
	| space light mesh rover win pc portal |
	Processor activeIsland id: self class islandID.
	space := TSpace new.
	space registerGlobal: #mainEntry.
	space color:(VectorColor r: 0.6 g: 0.5 b: 0.2 a: 1.0).

	light := TLight new.
	light rotationAroundZ: 120.
	light addRotationAroundY:2.
	light translationX: 10 y: 0 z:10.

	space addChild: light.

	rover := TRover new.
	rover translationX:10 y:-19.11 z:0.
	space addChild: rover.

	mesh := (TLoad3DSMax new initializeWithFileName: (FileDirectory pathFromURI: 'Content/Mars/masterTerrain.ASE') scale: 0.05) frame.
	mesh boundsDepth: 2.
	mesh initBounds.
	mesh translationX: 0.0 y: 22.0 z:0.0.
	TQuadTree new initializeWithSpace: space frame: mesh.

	win := self makePortal: nil.
	win rotationAroundY: 225.
	win translationX: 40.0 y:-17.0 z: 40.0.
	win openContents.
	pc := TPostcard new routerAddress: nil "don't know what it is"
				id: IntroWorld islandID
				name: 'Intro World'
				viewpointName: #MarsPortal.

	portal := win contents.
	portal postcardLink: pc.
	portal registerGlobal: #IntroPortal.
	space addChild: win.! !

BaseWorld subclass: #SpreadSheetWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HedgeHacks-BFD'!

!SpreadSheetWorld commentStamp: '<historical>' prior: 0!
The spreadsheet world constructor.!

!SpreadSheetWorld class methodsFor: 'as yet unclassified' stamp: 'ar 1/18/2006 11:45'!
islandID
	^TObjectID readHexFrom: '9d8a5fee5fdf61f7a6cf03b21484572d'! !

!SpreadSheetWorld methodsFor: 'initialize' stamp: 'hrs 11/15/2006 06:38'!
initialize
	| space light morphic win pc portal |
	Processor activeIsland id: self class islandID.
	space := TSpace new.
	space registerGlobal: #mainEntry.
	space color:(VectorColor r: 0.8 g: 0.8 b: 1.0 a: 1.0).
	light := TLight new.
	space addChild: light.
	light rotationAroundZ:125.

	morphic := self makeSpreadsheet: 1024@768.

	win := self makeWindow.
	win contents3D: morphic.
	win translation: (0@0.25@2).
	win matRectDown: win matRectNormal.
	win matRectOver: win matRectNormal.
	space addChild: win.

	self makeFloor: space fileName: 'graph128.bmp'.

	win := self makePortal: nil.
	win rotationAroundY: 180.
	win translationX: 0 y: 0.0 z: 40.0.
	win openContents.
	pc := TPostcard new routerAddress: nil "don't know what it is"
				id: IntroWorld islandID
				name: 'Intro World'
				viewpointName: #SpreadSheetPortal.

	portal := win contents.
	portal postcardLink: pc.
	portal registerGlobal: #IntroPortal.
	space addChild: win.
	^ space.

! !

!SpreadSheetWorld methodsFor: 'initialize' stamp: 'hrs 10/13/2006 19:03'!
makeSpreadsheet: worldExtent
	^TEmbeddedApp name: #TMorphicWorld extent: worldExtent 
		data: {#makeMorph:. SpreadSheet}.! !

BaseWorld subclass: #T3BodyWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HedgeHacks-BFD'!

!T3BodyWorld commentStamp: '<historical>' prior: 0!
The 3 body world constructor.!

!T3BodyWorld class methodsFor: 'as yet unclassified' stamp: 'ar 1/18/2006 11:42'!
islandID
	^TObjectID readHexFrom: '6ad7134a77da8a15cd3f50b8f688ef19'! !

!T3BodyWorld methodsFor: 'initialize' stamp: 'bgf 3/9/2006 17:20'!
initialize
	| light space tframe win pc portal |
	Processor activeIsland id: self class islandID.
	space := TSpace new.
	space color:  (VectorColor r: 0.0 g: 0.0 b: 0.0 a: 1.0).

	space registerGlobal: #mainEntry.

	light := TLight new.
	light ambientColor: #(0.3 0.3 0.3 1).
	light translationX: -10 y:0.0 z: 0.0.
	light rotationAroundX: -90.
	space addChild: light.

	tframe := T3BodyDemo new.
	space addChild: tframe.

	win := self makePortal: nil.
	win rotationAroundY: 225.
	win translationX: 40.0 y:10.0 z: 40.0.
	win openContents.
	pc := TPostcard new routerAddress: nil "don't know what it is"
				id: IntroWorld islandID
				name: 'Intro World'
				viewpointName: #T3BodyPortal.

	portal := win contents.
	portal postcardLink: pc.
	portal registerGlobal: #IntroPortal.
	space addChild: win.! !

BaseWorld subclass: #UnderwaterWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HedgeHacks-BFD'!

!UnderwaterWorld commentStamp: '<historical>' prior: 0!
The underwater world constructor.!

!UnderwaterWorld class methodsFor: 'as yet unclassified' stamp: 'ar 1/18/2006 11:44'!
islandID
	^TObjectID readHexFrom: '62ce4751d1ed616aba03dca56bda598a'! !

!UnderwaterWorld methodsFor: 'as yet unclassified' stamp: 'hrs 11/15/2006 06:38'!
initialize
	| space light floor floorMesh pic mat tMesh url win pc portal atar |
	Processor activeIsland id: self class islandID.
	space := TSpace new.
	space registerGlobal: #mainEntry.
	space color: (VectorColor r: 0.0 g: 0.45 b: 0.51 a: 1.0).
	space fogOn: true.
	space fogDensity: 0.025.
	space fogStart: 40.0.
	space fogEnd: 200.0.

	light := TLight new.
	light ambientColor: #(0.5 0.5 0.5 1.0).
	light diffuseColor: #(1.0  1.0  1.0  1.0).
	light specularColor: #(0.0 0.0 0.0 1.0).
	light rotationAroundZ: 220.
	light translationX: 0 y: 3 z: -15.
	space addChild: light.

	floor := TTexture new initializeWithFileName: 'floor.bmp' mipmap: true shrinkFit: false.
	floor rotationAroundX: -90.
	floor translationX: 0 y: -2.0 z: -3.0.
	floor uvScale: 8.0@8.0.
	floor extent: 40.0@40.0.

	floorMesh := (FileStream readOnlyFileNamed: (FileDirectory pathFromURI: 'Content/Underwater/topo.mesh')) fileInObjectAndCode.
	pic := TTexture new initializeWithFileName: (FileDirectory pathFromURI: 'Content/Underwater/Waves1.jpg').
	mat := TMaterial new.
	mat ambientColor: #(0.2 0.4 0.3 1).
	mat diffuseColor: #(0.2 0.4 0.3 1).
	mat texture: pic.
	mat textureMode: GLModulate.
	tMesh := TMesh
				initializeWithVertices: floorMesh vertices 
				alias: nil 
				norms: floorMesh vertexNormals
				textureUV: floorMesh texCoords
				faceGroups: {1. floorMesh zeroBasedFaceGroup}
				material: mat.
	tMesh initBounds.
	tMesh solid: true.
	tMesh translationX: 0 y: -76 z: 0.
	tMesh material ambientColor: #(1 1 1 1).
	tMesh material diffuseColor: #(1 1 1 1).
	space addChild: tMesh.

	atar := self makeSomeFish: space target: light.
	space defaultAvatar: (TIslandCopier new export: atar).

	#(
		('Content/Underwater/tutorials/embedded/fishScript/fishScript.html' -10 1 -22 30)
		('Content/Underwater/tutorials/embedded/fishPaint/fishPaint.html' 10 1 -22 -30)
	) do:[:spec|
		url := spec first. "look locally only"
		pic := self makeWebPage: url extent: 512@256.

		win := self makeWindow.
		win translationX: spec second y: spec third z: spec fourth.
		win rotationAroundY: spec fifth.
		win contents: pic.
		space addChild: win.
	].

	win := self makePortal: nil.
	win rotationAroundY: 180.
	win translationX: 0.0 y:0.0 z: 3.0.
	win openContents.
	pc := TPostcard new routerAddress: nil "don't know what it is"
				id: IntroWorld islandID
				name: 'Intro World'
				viewpointName: #UnderwaterPortal.

	portal := win contents.
	portal postcardLink: pc.
	portal registerGlobal: #IntroPortal.
	space addChild: win.
! !

!UnderwaterWorld methodsFor: 'as yet unclassified' stamp: 'ar 3/15/2006 14:48'!
loadNewFish
	| mesh tMesh mat |
	mesh := (FileStream readOnlyFileNamed:(FileDirectory pathFromURI: 'Content/Underwater/fish.mesh')) fileInObjectAndCode.
	mat := TMaterial new.
	mat ambientColor: #(1 1 1 1).
	mat diffuseColor: #(1 1 1 1).
	tMesh := TMesh 
				initializeWithVertices: mesh vertices 
				alias: nil 
				norms: mesh vertexNormals
				textureUV: mesh texCoords
				faceGroups: {1. mesh zeroBasedFaceGroup}
				material: mat.
	tMesh initBounds.
	^tMesh! !

!UnderwaterWorld methodsFor: 'as yet unclassified' stamp: 'ar 2/1/2006 18:32'!
makeSomeFish: sp target: fishTarget
	| pic1 pic2 pic3 rnd fish frame |
	pic1 := TTexture new initializeWithFileName: (FileDirectory pathFromURI: 'Content/Underwater/OpalEye.jpg') mipmap: true shrinkFit: false.
	pic2 := TTexture new initializeWithFileName: (FileDirectory pathFromURI: 'Content/Underwater/RockFish.jpg') mipmap: true shrinkFit: false.
	pic3 := TTexture new initializeWithFileName: (FileDirectory pathFromURI: 'Content/Underwater/Seniorita.jpg') mipmap: true shrinkFit: false.
	rnd := Random seed: 123456.
	{pic1. pic2. pic3} do:[:tex|
		1 to: 4 do:[:i|
			fish  := self loadNewFish.
			fish scale: 3.
			fish solid: false.
			fish objectName: 'fish'.
			fish material texture: tex.
			fish material textureMode: GLModulate.
			frame := TDemoFish new.
			frame normalMaterial: fish material.
			frame target: fishTarget.
			frame translationX: rnd next * 20 - 10 y: rnd next z: rnd next * 20 - 10.
			frame contents: fish.
			sp addChild: frame.
		].
	].

	fish  := self loadNewFish.
	fish solid: false.
	fish scale: 3.
	fish objectName: 'fish'.
	fish material texture: pic1.
	fish material textureMode: GLModulate.
	^fish! !

!UnderwaterWorld methodsFor: 'as yet unclassified' stamp: 'bgf 9/8/2006 17:56'!
makeWebPage: url extent: pageExtent
	
	^ TEmbeddedApp name: #TMorphicWorld
						extent: pageExtent
						data: { #makeHTMLEditor: . url}.
! !
